local mod = ...



-- Asset Processor
mod:registerAssetProcessor("models/Desert3.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Texture -------------------------------------------------------------------------------------
mod:registerAssetId("models/Desert3.fbx/Materials/Material.PalmLeaf1", "MATERIAL_TROPICAL_PALMLEAF1")
mod:overrideAsset({
	Id = "MATERIAL_TROPICAL_PALMLEAF1",
    HasAlphaTest = true,
    BackFaceVisible = true,
})

mod:registerAssetId("models/Desert3.fbx/Materials/Material.PalmLeaf2", "MATERIAL_TROPICAL_PALMLEAF2")
mod:overrideAsset({
	Id = "MATERIAL_TROPICAL_PALMLEAF2",
    HasAlphaTest = true,
    BackFaceVisible = true,
})

mod:registerAssetId("models/Desert3.fbx/Materials/Material.PalmLeaf3", "MATERIAL_TROPICAL_PALMLEAF3")
mod:overrideAsset({
	Id = "MATERIAL_TROPICAL_PALMLEAF3",
    HasAlphaTest = true,
    BackFaceVisible = true,
})

mod:registerAssetId("models/Desert3.fbx/Materials/Material.Flower1", "MATERIAL_TROPICAL_FLOWER1")
mod:overrideAsset({
	Id = "MATERIAL_TROPICAL_FLOWER1",
    HasAlphaTest = true,
    BackFaceVisible = true,
})




-- Plantable & Resource -------------------------------------------------------------------------------------

-- Date
mod:registerAssetId("models/Desert3.fbx/Prefab/Tree.Date.001", "PREFAB_TROPICAL_TREE_DATE")

-- mod:registerPrefabComponent( "PREFAB_TROPICAL_TREE_DATE", { DataType = "COMP_DIRT_CIRCLE", HardRadius = 0.5, SoftRadius = 1.5, Strength = 0.25, })

mod:registerPrefabComponent( "PREFAB_TROPICAL_TREE_DATE", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "BERRIES",
    IsReplenishable = true,
    ReplenishDurationInDays = 14,
    ReplenishQuantity = 1,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 0.85, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false,
})

mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_DATE", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_DATE", { DataType = "COMP_TREE" })
mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_DATE", { DataType = "COMP_GROUNDED", AutoDisable = true })

mod:registerAsset({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_TROPICAL_TREE_DATE",
    Name = "TROPICAL_TREE_DATE_NAME",
    PlantPrefab = "PREFAB_TROPICAL_TREE_DATE",
    Icon = "ICON_RESOURCE_BERRIES",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


-- Palm
for i = 1, 2 do

    mod:registerAssetId("models/Desert3.fbx/Prefab/Tree.Palm.00" .. i, "PREFAB_TROPICAL_TREE_PALM" .. i)

    -- mod:registerPrefabComponent( "PREFAB_TROPICAL_TREE_PALM" .. i, { DataType = "COMP_DIRT_CIRCLE", HardRadius = 0.5, SoftRadius = 2.5, Strength = 0.25, })

    mod:registerPrefabComponent( "PREFAB_TROPICAL_TREE_PALM" .. i, {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = "WOOD",
        IsReplenishable = false,
        ResourceValue = 1.0, -- how many are gathered with each pick
        AvailableQuantity = 1, -- maximum container stock
        Radius = 0.85, -- distance from container that the villager will stand to pick
        IsDestroyWhenEmpty = true,
    })

    mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_PALM" .. i, { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
    mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_PALM" .. i, { DataType = "COMP_TREE" })
    mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_PALM" .. i, { DataType = "COMP_GROUNDED", AutoDisable = true })

    mod:registerAsset({
        DataType = "PLANTABLE",
        Id = "PLANTABLE_TROPICAL_TREE_PALM" .. i,
        Name = "TROPICAL_TREE_PALM" .. i .. "_NAME",
        PlantPrefab = "PREFAB_TROPICAL_TREE_PALM" .. i,
        Icon = "ICON_RESOURCE_WOOD",
        MinimumScale = 0.85, -- min size at full growth
        MaximumScale = 1.15 -- max size at full growth
    })

end

-- Cane
mod:registerAssetId("models/Desert3.fbx/Prefab/Tree.Cane.001", "PREFAB_TROPICAL_TREE_CANE")

-- mod:registerPrefabComponent( "PREFAB_TROPICAL_TREE_CANE", { DataType = "COMP_DIRT_CIRCLE", HardRadius = 0.5, SoftRadius = 1.5, Strength = 0.25, })

mod:registerPrefabComponent( "PREFAB_TROPICAL_TREE_CANE", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 0.85, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
})

mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_CANE", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_CANE", { DataType = "COMP_TREE" })
mod:registerPrefabComponent("PREFAB_TROPICAL_TREE_CANE", { DataType = "COMP_GROUNDED", AutoDisable = true })

mod:registerAsset({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_TROPICAL_TREE_CANE",
    Name = "TROPICAL_TREE_CANE_NAME",
    PlantPrefab = "PREFAB_TROPICAL_TREE_CANE",
    Icon = "ICON_RESOURCE_WOOD",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})



-- Flowers  ---------------------------------------------------------------------------------------------
for i = 1, 4 do

    mod:registerAssetId("models/Desert3.fbx/Prefab/Flower.00" .. i, "PREFAB_TROPICAL_FLOWER" .. i)

    -- mod:registerPrefabComponent( "PREFAB_TROPICAL_TREE_DATE", { DataType = "COMP_DIRT_CIRCLE", HardRadius = 0.5, SoftRadius = 1.5, Strength = 0.25, })

    mod:registerPrefabComponent( "PREFAB_TROPICAL_FLOWER" .. i, {
        DataType = "COMP_RESOURCE_CONTAINER",
        ResourceData = "HERBS",
        IsReplenishable = false,
        ResourceValue = 1.0, -- how many are gathered with each pick
        AvailableQuantity = 1, -- maximum container stock
        Radius = 0.85, -- distance from container that the villager will stand to pick
        IsDestroyWhenEmpty = true,
    })

    mod:registerPrefabComponent("PREFAB_TROPICAL_FLOWER" .. i, { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 5.0 })
    mod:registerPrefabComponent("PREFAB_TROPICAL_FLOWER" .. i, { DataType = "COMP_TREE" })
    mod:registerPrefabComponent("PREFAB_TROPICAL_FLOWER" .. i, { DataType = "COMP_GROUNDED", AutoDisable = true })

end


-- Forester -------------------------------------------------------------------------
mod:overrideAsset({
    Id = "BUILDING_FUNCTION_FORESTER",
    PlantableAssetList = {
        Action = "APPEND",
        "PLANTABLE_TROPICAL_TREE_DATE",
        "PLANTABLE_TROPICAL_TREE_PALM1",
        "PLANTABLE_TROPICAL_TREE_PALM2",
        "PLANTABLE_TROPICAL_TREE_CANE",
    },
})



-- Building -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "BUILDING",
	Id = "BUILDING_TROPICAL",
	Name = "BUILDING_TROPICAL_NAME",
	Description = "BUILDING_TROPICAL_DESC",
	BuildingType = "MODS",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "CORE",
			BuildingPartList = {
				"BUILDING_PART_TROPICAL_TREE_DATE",
				"BUILDING_PART_TROPICAL_TREE_PALM1",
				"BUILDING_PART_TROPICAL_TREE_PALM2",
				"BUILDING_PART_TROPICAL_TREE_CANE",
				"BUILDING_PART_TROPICAL_FLOWER1",
				"BUILDING_PART_TROPICAL_FLOWER2",
				"BUILDING_PART_TROPICAL_FLOWER3",
				"BUILDING_PART_TROPICAL_FLOWER4",
			},
        },
    },
})



-- Building parts -------------------------------------------------------------------------------------
local function registerPart(name)

    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_TROPICAL_" .. name,
        Name = "TROPICAL_" .. name .. "_NAME",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_TROPICAL_" .. name,
            MiniatureConfig = {
                ClipUnderGround = true,
                GroupHeight = 0.0,
                CameraPosition = { 0.0, 0, 0 },
                OrientationOffset = 0,
                CameraPitchOffset = 25.0
            },
        },
        IsMovableWhenBuilt = true,
        DesirabilityModifiers = {
            {
                Desirability = "DESIRABILITY_RESIDENTIAL",
                Type = "ADD",
                Radius = 5.0,
                Value = 0.5
            },
        },
    })

end

registerPart("TREE_DATE")
registerPart("TREE_PALM1")
registerPart("TREE_PALM2")
registerPart("TREE_CANE")
registerPart("FLOWER1")
registerPart("FLOWER2")
registerPart("FLOWER3")
registerPart("FLOWER4")



mod:overrideAsset({
    Id = "BUILDING_PART_TROPICAL_TREE_DATE",
    Description = "BUILDING_PART_TROPICAL_TREE_DATE_DESC",
})

mod:overrideAsset({
    Id = "BUILDING_PART_TROPICAL_TREE_PALM1",
    Description = "BUILDING_PART_TROPICAL_TREE_PALM_DESC",
})

mod:overrideAsset({
    Id = "BUILDING_PART_TROPICAL_TREE_PALM2",
    Description = "BUILDING_PART_TROPICAL_TREE_PALM_DESC",
})

mod:overrideAsset({
    Id = "BUILDING_PART_TROPICAL_TREE_CANE",
    Description = "BUILDING_PART_TROPICAL_TREE_PALM_DESC",
})

